package de.bsvrz.datex2.test.mockclasses;
import java.util.Arrays;
import java.util.List;

import de.bsvrz.dav.daf.main.ClientDavConnection;
import de.bsvrz.dav.daf.main.ClientDavParameters;
import de.bsvrz.dav.daf.main.CommunicationError;
import de.bsvrz.dav.daf.main.ConnectionException;
import de.bsvrz.dav.daf.main.DataNotSubscribedException;
import de.bsvrz.dav.daf.main.InconsistentLoginException;
import de.bsvrz.dav.daf.main.MissingParameterException;
import de.bsvrz.dav.daf.main.OneSubscriptionPerSendData;
import de.bsvrz.dav.daf.main.SendSubscriptionNotConfirmed;
import de.bsvrz.dav.daf.main.config.ConfigurationObject;
import de.bsvrz.dav.daf.main.config.MutableCollection;
import de.bsvrz.dav.daf.main.config.MutableCollectionChangeListener;
import de.bsvrz.dav.daf.main.config.ObjectSetType;
import de.bsvrz.dav.daf.main.config.SystemObject;
import de.bsvrz.dav.daf.main.config.SystemObjectType;


public class SubscribeSet implements MutableCollectionChangeListener {
  ClientDavConnection davConnection;
  
  public void initialize(String[] args) throws MissingParameterException, CommunicationError, ConnectionException, InconsistentLoginException {
    ClientDavParameters parameters = new ClientDavParameters(args);
    davConnection = new ClientDavConnection(parameters);
    davConnection.connect();
    davConnection.login();
  }
   
  public void teardown() {
    davConnection.disconnect(false, "About to die...");
  }
  
  public void doit() {
    ConfigurationObject co = (ConfigurationObject) davConnection.getDataModel().getObject("betriebMeldung.tg");
    MutableCollection objectSet = co.getMutableSet("Meldungen");
    ObjectSetType x = co.getObjectSet("Meldungen").getObjectSetType();
    
    for (SystemObjectType xt : x.getObjectTypes()) {
      System.err.println("Typ: " + xt.getPidOrNameOrId() );
    }
    System.err.println("Mengen: " + Arrays.asList(co.getObjectSets()));
 
    objectSet.addChangeListener((short) 0, this);  
  }

  public static void main(String[] args) throws MissingParameterException, CommunicationError, ConnectionException, InconsistentLoginException, DataNotSubscribedException, SendSubscriptionNotConfirmed, OneSubscriptionPerSendData, InterruptedException {
    SubscribeSet instance = new SubscribeSet();

    System.err.println("Initialize...");
    instance.initialize(args);

    System.err.println("Subscribe...");

    instance.doit();

    System.err.println("Wait...");
    
    Thread.sleep(100000);
    instance.teardown();
  }

  @Override
  public void collectionChanged(MutableCollection arg0, short arg1, List<SystemObject> arg2, List<SystemObject> arg3) {
    System.err.println("Addded: " + arg2);
    System.err.println("Removed: " + arg3);
  }

}
